/* Imported API files */
#include <vnet/ipsec/ipsec_types.api_tojson.h>
#include <vnet/interface_types.api_tojson.h>
#include <vnet/ip/ip_types.api_tojson.h>
#include <vnet/interface_types.api_tojson.h>
#include <vnet/tunnel/tunnel_types.api_tojson.h>
#ifndef included_ipsec_api_tojson_h
#define included_ipsec_api_tojson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline cJSON *vl_api_ipsec_spd_action_t_tojson (vl_api_ipsec_spd_action_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("IPSEC_API_SPD_ACTION_BYPASS");
    case 1:
        return cJSON_CreateString("IPSEC_API_SPD_ACTION_DISCARD");
    case 2:
        return cJSON_CreateString("IPSEC_API_SPD_ACTION_RESOLVE");
    case 3:
        return cJSON_CreateString("IPSEC_API_SPD_ACTION_PROTECT");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_ipsec_spd_entry_t_tojson (vl_api_ipsec_spd_entry_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddNumberToObject(o, "spd_id", a->spd_id);
    cJSON_AddNumberToObject(o, "priority", a->priority);
    cJSON_AddBoolToObject(o, "is_outbound", a->is_outbound);
    cJSON_AddNumberToObject(o, "sa_id", a->sa_id);
    cJSON_AddItemToObject(o, "policy", vl_api_ipsec_spd_action_t_tojson(a->policy));
    cJSON_AddNumberToObject(o, "protocol", a->protocol);
    cJSON_AddItemToObject(o, "remote_address_start", vl_api_address_t_tojson(&a->remote_address_start));
    cJSON_AddItemToObject(o, "remote_address_stop", vl_api_address_t_tojson(&a->remote_address_stop));
    cJSON_AddItemToObject(o, "local_address_start", vl_api_address_t_tojson(&a->local_address_start));
    cJSON_AddItemToObject(o, "local_address_stop", vl_api_address_t_tojson(&a->local_address_stop));
    cJSON_AddNumberToObject(o, "remote_port_start", a->remote_port_start);
    cJSON_AddNumberToObject(o, "remote_port_stop", a->remote_port_stop);
    cJSON_AddNumberToObject(o, "local_port_start", a->local_port_start);
    cJSON_AddNumberToObject(o, "local_port_stop", a->local_port_stop);
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_t_tojson (vl_api_ipsec_tunnel_protect_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddItemToObject(o, "nh", vl_api_address_t_tojson(&a->nh));
    cJSON_AddNumberToObject(o, "sa_out", a->sa_out);
    cJSON_AddNumberToObject(o, "n_sa_in", a->n_sa_in);
    {
        int i;
        cJSON *array = cJSON_AddArrayToObject(o, "sa_in");
        for (i = 0; i < a->n_sa_in; i++) {
            cJSON_AddItemToArray(array, cJSON_CreateNumber(a->sa_in[i]));
        }
    }
    return o;
}
static inline cJSON *vl_api_ipsec_itf_t_tojson (vl_api_ipsec_itf_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddNumberToObject(o, "user_instance", a->user_instance);
    cJSON_AddItemToObject(o, "mode", vl_api_tunnel_mode_t_tojson(a->mode));
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_ipsec_spd_add_del_t_tojson (vl_api_ipsec_spd_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_add_del");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddNumberToObject(o, "spd_id", a->spd_id);
    return o;
}
static inline cJSON *vl_api_ipsec_spd_add_del_reply_t_tojson (vl_api_ipsec_spd_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_interface_add_del_spd_t_tojson (vl_api_ipsec_interface_add_del_spd_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_interface_add_del_spd");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "spd_id", a->spd_id);
    return o;
}
static inline cJSON *vl_api_ipsec_interface_add_del_spd_reply_t_tojson (vl_api_ipsec_interface_add_del_spd_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_interface_add_del_spd_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_spd_entry_add_del_t_tojson (vl_api_ipsec_spd_entry_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_entry_add_del");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_spd_entry_t_tojson(&a->entry));
    return o;
}
static inline cJSON *vl_api_ipsec_spd_entry_add_del_reply_t_tojson (vl_api_ipsec_spd_entry_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_entry_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_spds_dump_t_tojson (vl_api_ipsec_spds_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spds_dump");
    return o;
}
static inline cJSON *vl_api_ipsec_spds_details_t_tojson (vl_api_ipsec_spds_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spds_details");
    cJSON_AddNumberToObject(o, "spd_id", a->spd_id);
    cJSON_AddNumberToObject(o, "npolicies", a->npolicies);
    return o;
}
static inline cJSON *vl_api_ipsec_spd_dump_t_tojson (vl_api_ipsec_spd_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_dump");
    cJSON_AddNumberToObject(o, "spd_id", a->spd_id);
    cJSON_AddNumberToObject(o, "sa_id", a->sa_id);
    return o;
}
static inline cJSON *vl_api_ipsec_spd_details_t_tojson (vl_api_ipsec_spd_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_details");
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_spd_entry_t_tojson(&a->entry));
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_del_t_tojson (vl_api_ipsec_sad_entry_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_del");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_t_tojson(&a->entry));
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_del_v2_t_tojson (vl_api_ipsec_sad_entry_add_del_v2_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_del_v2");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_v2_t_tojson(&a->entry));
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_del_v3_t_tojson (vl_api_ipsec_sad_entry_add_del_v3_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_del_v3");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_v3_t_tojson(&a->entry));
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_t_tojson (vl_api_ipsec_sad_entry_add_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add");
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_v3_t_tojson(&a->entry));
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_del_t_tojson (vl_api_ipsec_sad_entry_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_del");
    cJSON_AddNumberToObject(o, "id", a->id);
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_del_reply_t_tojson (vl_api_ipsec_sad_entry_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_del_reply_t_tojson (vl_api_ipsec_sad_entry_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_del_v2_reply_t_tojson (vl_api_ipsec_sad_entry_add_del_v2_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_del_v2_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_del_v3_reply_t_tojson (vl_api_ipsec_sad_entry_add_del_v3_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_del_v3_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_sad_entry_add_reply_t_tojson (vl_api_ipsec_sad_entry_add_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sad_entry_add_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_update_t_tojson (vl_api_ipsec_tunnel_protect_update_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_tunnel_protect_update");
    cJSON_AddItemToObject(o, "tunnel", vl_api_ipsec_tunnel_protect_t_tojson(&a->tunnel));
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_update_reply_t_tojson (vl_api_ipsec_tunnel_protect_update_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_tunnel_protect_update_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_del_t_tojson (vl_api_ipsec_tunnel_protect_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_tunnel_protect_del");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddItemToObject(o, "nh", vl_api_address_t_tojson(&a->nh));
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_del_reply_t_tojson (vl_api_ipsec_tunnel_protect_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_tunnel_protect_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_dump_t_tojson (vl_api_ipsec_tunnel_protect_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_tunnel_protect_dump");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_ipsec_tunnel_protect_details_t_tojson (vl_api_ipsec_tunnel_protect_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_tunnel_protect_details");
    cJSON_AddItemToObject(o, "tun", vl_api_ipsec_tunnel_protect_t_tojson(&a->tun));
    return o;
}
static inline cJSON *vl_api_ipsec_spd_interface_dump_t_tojson (vl_api_ipsec_spd_interface_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_interface_dump");
    cJSON_AddNumberToObject(o, "spd_index", a->spd_index);
    cJSON_AddNumberToObject(o, "spd_index_valid", a->spd_index_valid);
    return o;
}
static inline cJSON *vl_api_ipsec_spd_interface_details_t_tojson (vl_api_ipsec_spd_interface_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_spd_interface_details");
    cJSON_AddNumberToObject(o, "spd_index", a->spd_index);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_ipsec_itf_create_t_tojson (vl_api_ipsec_itf_create_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_itf_create");
    cJSON_AddItemToObject(o, "itf", vl_api_ipsec_itf_t_tojson(&a->itf));
    return o;
}
static inline cJSON *vl_api_ipsec_itf_create_reply_t_tojson (vl_api_ipsec_itf_create_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_itf_create_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_ipsec_itf_delete_t_tojson (vl_api_ipsec_itf_delete_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_itf_delete");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_ipsec_itf_delete_reply_t_tojson (vl_api_ipsec_itf_delete_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_itf_delete_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_itf_dump_t_tojson (vl_api_ipsec_itf_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_itf_dump");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_ipsec_itf_details_t_tojson (vl_api_ipsec_itf_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_itf_details");
    cJSON_AddItemToObject(o, "itf", vl_api_ipsec_itf_t_tojson(&a->itf));
    return o;
}
static inline cJSON *vl_api_ipsec_sa_dump_t_tojson (vl_api_ipsec_sa_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sa_dump");
    cJSON_AddNumberToObject(o, "sa_id", a->sa_id);
    return o;
}
static inline cJSON *vl_api_ipsec_sa_v2_dump_t_tojson (vl_api_ipsec_sa_v2_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sa_v2_dump");
    cJSON_AddNumberToObject(o, "sa_id", a->sa_id);
    return o;
}
static inline cJSON *vl_api_ipsec_sa_v3_dump_t_tojson (vl_api_ipsec_sa_v3_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sa_v3_dump");
    cJSON_AddNumberToObject(o, "sa_id", a->sa_id);
    return o;
}
static inline cJSON *vl_api_ipsec_sa_details_t_tojson (vl_api_ipsec_sa_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sa_details");
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_t_tojson(&a->entry));
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "salt", a->salt);
    cJSON_AddNumberToObject(o, "seq_outbound", a->seq_outbound);
    cJSON_AddNumberToObject(o, "last_seq_inbound", a->last_seq_inbound);
    cJSON_AddNumberToObject(o, "replay_window", a->replay_window);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_sa_v2_details_t_tojson (vl_api_ipsec_sa_v2_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sa_v2_details");
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_v2_t_tojson(&a->entry));
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "salt", a->salt);
    cJSON_AddNumberToObject(o, "seq_outbound", a->seq_outbound);
    cJSON_AddNumberToObject(o, "last_seq_inbound", a->last_seq_inbound);
    cJSON_AddNumberToObject(o, "replay_window", a->replay_window);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_sa_v3_details_t_tojson (vl_api_ipsec_sa_v3_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_sa_v3_details");
    cJSON_AddItemToObject(o, "entry", vl_api_ipsec_sad_entry_v3_t_tojson(&a->entry));
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "seq_outbound", a->seq_outbound);
    cJSON_AddNumberToObject(o, "last_seq_inbound", a->last_seq_inbound);
    cJSON_AddNumberToObject(o, "replay_window", a->replay_window);
    cJSON_AddNumberToObject(o, "stat_index", a->stat_index);
    return o;
}
static inline cJSON *vl_api_ipsec_backend_dump_t_tojson (vl_api_ipsec_backend_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_backend_dump");
    return o;
}
static inline cJSON *vl_api_ipsec_backend_details_t_tojson (vl_api_ipsec_backend_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_backend_details");
    cJSON_AddStringToObject(o, "name", (char *)a->name);
    cJSON_AddItemToObject(o, "protocol", vl_api_ipsec_proto_t_tojson(a->protocol));
    cJSON_AddNumberToObject(o, "index", a->index);
    cJSON_AddBoolToObject(o, "active", a->active);
    return o;
}
static inline cJSON *vl_api_ipsec_select_backend_t_tojson (vl_api_ipsec_select_backend_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_select_backend");
    cJSON_AddItemToObject(o, "protocol", vl_api_ipsec_proto_t_tojson(a->protocol));
    cJSON_AddNumberToObject(o, "index", a->index);
    return o;
}
static inline cJSON *vl_api_ipsec_select_backend_reply_t_tojson (vl_api_ipsec_select_backend_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_select_backend_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_ipsec_set_async_mode_t_tojson (vl_api_ipsec_set_async_mode_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_set_async_mode");
    cJSON_AddBoolToObject(o, "async_enable", a->async_enable);
    return o;
}
static inline cJSON *vl_api_ipsec_set_async_mode_reply_t_tojson (vl_api_ipsec_set_async_mode_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "ipsec_set_async_mode_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
#endif
