/* Imported API files */
#include <vnet/interface_types.api_tojson.h>
#include <vnet/ip/ip_types.api_tojson.h>
#ifndef included_session_api_tojson_h
#define included_session_api_tojson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline cJSON *vl_api_transport_proto_t_tojson (vl_api_transport_proto_t a) {
    switch(a) {
    case 1:
        return cJSON_CreateString("TRANSPORT_PROTO_API_TCP");
    case 2:
        return cJSON_CreateString("TRANSPORT_PROTO_API_UDP");
    case 3:
        return cJSON_CreateString("TRANSPORT_PROTO_API_NONE");
    case 4:
        return cJSON_CreateString("TRANSPORT_PROTO_API_TLS");
    case 5:
        return cJSON_CreateString("TRANSPORT_PROTO_API_QUIC");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_session_rule_scope_t_tojson (vl_api_session_rule_scope_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("SESSION_RULE_SCOPE_API_GLOBAL");
    case 1:
        return cJSON_CreateString("SESSION_RULE_SCOPE_API_LOCAL");
    case 2:
        return cJSON_CreateString("SESSION_RULE_SCOPE_API_BOTH");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_app_attach_t_tojson (vl_api_app_attach_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_attach");
    {
        int i;
        cJSON *array = cJSON_AddArrayToObject(o, "options");
        for (i = 0; i < 18; i++) {
            cJSON_AddItemToArray(array, cJSON_CreateNumber(a->options[i]));
        }
    }
    vl_api_string_cJSON_AddToObject(o, "namespace_id", &a->namespace_id);
    return o;
}
static inline cJSON *vl_api_app_attach_reply_t_tojson (vl_api_app_attach_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_attach_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "app_mq", a->app_mq);
    cJSON_AddNumberToObject(o, "vpp_ctrl_mq", a->vpp_ctrl_mq);
    cJSON_AddNumberToObject(o, "vpp_ctrl_mq_thread", a->vpp_ctrl_mq_thread);
    cJSON_AddNumberToObject(o, "app_index", a->app_index);
    cJSON_AddNumberToObject(o, "n_fds", a->n_fds);
    cJSON_AddNumberToObject(o, "fd_flags", a->fd_flags);
    cJSON_AddNumberToObject(o, "segment_size", a->segment_size);
    cJSON_AddNumberToObject(o, "segment_handle", a->segment_handle);
    vl_api_string_cJSON_AddToObject(o, "segment_name", &a->segment_name);
    return o;
}
static inline cJSON *vl_api_application_detach_t_tojson (vl_api_application_detach_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "application_detach");
    return o;
}
static inline cJSON *vl_api_application_detach_reply_t_tojson (vl_api_application_detach_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "application_detach_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_app_add_cert_key_pair_t_tojson (vl_api_app_add_cert_key_pair_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_add_cert_key_pair");
    cJSON_AddNumberToObject(o, "cert_len", a->cert_len);
    cJSON_AddNumberToObject(o, "certkey_len", a->certkey_len);
    {
    u8 *s = format(0, "0x%U", format_hex_bytes, &a->certkey, a->certkey_len);
    cJSON_AddStringToObject(o, "certkey", (char *)s);
    vec_free(s);
    }
    return o;
}
static inline cJSON *vl_api_app_add_cert_key_pair_reply_t_tojson (vl_api_app_add_cert_key_pair_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_add_cert_key_pair_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "index", a->index);
    return o;
}
static inline cJSON *vl_api_app_del_cert_key_pair_t_tojson (vl_api_app_del_cert_key_pair_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_del_cert_key_pair");
    cJSON_AddNumberToObject(o, "index", a->index);
    return o;
}
static inline cJSON *vl_api_app_del_cert_key_pair_reply_t_tojson (vl_api_app_del_cert_key_pair_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_del_cert_key_pair_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_application_tls_cert_add_t_tojson (vl_api_application_tls_cert_add_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "application_tls_cert_add");
    cJSON_AddNumberToObject(o, "app_index", a->app_index);
    cJSON_AddNumberToObject(o, "cert_len", a->cert_len);
    {
    u8 *s = format(0, "0x%U", format_hex_bytes, &a->cert, a->cert_len);
    cJSON_AddStringToObject(o, "cert", (char *)s);
    vec_free(s);
    }
    return o;
}
static inline cJSON *vl_api_application_tls_cert_add_reply_t_tojson (vl_api_application_tls_cert_add_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "application_tls_cert_add_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_application_tls_key_add_t_tojson (vl_api_application_tls_key_add_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "application_tls_key_add");
    cJSON_AddNumberToObject(o, "app_index", a->app_index);
    cJSON_AddNumberToObject(o, "key_len", a->key_len);
    {
    u8 *s = format(0, "0x%U", format_hex_bytes, &a->key, a->key_len);
    cJSON_AddStringToObject(o, "key", (char *)s);
    vec_free(s);
    }
    return o;
}
static inline cJSON *vl_api_application_tls_key_add_reply_t_tojson (vl_api_application_tls_key_add_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "application_tls_key_add_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_app_worker_add_del_t_tojson (vl_api_app_worker_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_worker_add_del");
    cJSON_AddNumberToObject(o, "app_index", a->app_index);
    cJSON_AddNumberToObject(o, "wrk_index", a->wrk_index);
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    return o;
}
static inline cJSON *vl_api_app_worker_add_del_reply_t_tojson (vl_api_app_worker_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_worker_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "wrk_index", a->wrk_index);
    cJSON_AddNumberToObject(o, "app_event_queue_address", a->app_event_queue_address);
    cJSON_AddNumberToObject(o, "n_fds", a->n_fds);
    cJSON_AddNumberToObject(o, "fd_flags", a->fd_flags);
    cJSON_AddNumberToObject(o, "segment_handle", a->segment_handle);
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    vl_api_string_cJSON_AddToObject(o, "segment_name", &a->segment_name);
    return o;
}
static inline cJSON *vl_api_session_enable_disable_t_tojson (vl_api_session_enable_disable_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "session_enable_disable");
    cJSON_AddBoolToObject(o, "is_enable", a->is_enable);
    return o;
}
static inline cJSON *vl_api_session_enable_disable_reply_t_tojson (vl_api_session_enable_disable_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "session_enable_disable_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_app_namespace_add_del_t_tojson (vl_api_app_namespace_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_namespace_add_del");
    cJSON_AddNumberToObject(o, "secret", a->secret);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "ip4_fib_id", a->ip4_fib_id);
    cJSON_AddNumberToObject(o, "ip6_fib_id", a->ip6_fib_id);
    vl_api_string_cJSON_AddToObject(o, "namespace_id", &a->namespace_id);
    return o;
}
static inline cJSON *vl_api_app_namespace_add_del_v2_t_tojson (vl_api_app_namespace_add_del_v2_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_namespace_add_del_v2");
    cJSON_AddNumberToObject(o, "secret", a->secret);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "ip4_fib_id", a->ip4_fib_id);
    cJSON_AddNumberToObject(o, "ip6_fib_id", a->ip6_fib_id);
    cJSON_AddStringToObject(o, "namespace_id", (char *)a->namespace_id);
    cJSON_AddStringToObject(o, "netns", (char *)a->netns);
    return o;
}
static inline cJSON *vl_api_app_namespace_add_del_v3_t_tojson (vl_api_app_namespace_add_del_v3_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_namespace_add_del_v3");
    cJSON_AddNumberToObject(o, "secret", a->secret);
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddNumberToObject(o, "ip4_fib_id", a->ip4_fib_id);
    cJSON_AddNumberToObject(o, "ip6_fib_id", a->ip6_fib_id);
    cJSON_AddStringToObject(o, "namespace_id", (char *)a->namespace_id);
    cJSON_AddStringToObject(o, "netns", (char *)a->netns);
    vl_api_string_cJSON_AddToObject(o, "sock_name", &a->sock_name);
    return o;
}
static inline cJSON *vl_api_app_namespace_add_del_reply_t_tojson (vl_api_app_namespace_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_namespace_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "appns_index", a->appns_index);
    return o;
}
static inline cJSON *vl_api_app_namespace_add_del_v2_reply_t_tojson (vl_api_app_namespace_add_del_v2_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_namespace_add_del_v2_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "appns_index", a->appns_index);
    return o;
}
static inline cJSON *vl_api_app_namespace_add_del_v3_reply_t_tojson (vl_api_app_namespace_add_del_v3_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "app_namespace_add_del_v3_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "appns_index", a->appns_index);
    return o;
}
static inline cJSON *vl_api_session_rule_add_del_t_tojson (vl_api_session_rule_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "session_rule_add_del");
    cJSON_AddItemToObject(o, "transport_proto", vl_api_transport_proto_t_tojson(a->transport_proto));
    cJSON_AddItemToObject(o, "lcl", vl_api_prefix_t_tojson(&a->lcl));
    cJSON_AddItemToObject(o, "rmt", vl_api_prefix_t_tojson(&a->rmt));
    cJSON_AddNumberToObject(o, "lcl_port", a->lcl_port);
    cJSON_AddNumberToObject(o, "rmt_port", a->rmt_port);
    cJSON_AddNumberToObject(o, "action_index", a->action_index);
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddNumberToObject(o, "appns_index", a->appns_index);
    cJSON_AddItemToObject(o, "scope", vl_api_session_rule_scope_t_tojson(a->scope));
    cJSON_AddStringToObject(o, "tag", (char *)a->tag);
    return o;
}
static inline cJSON *vl_api_session_rule_add_del_reply_t_tojson (vl_api_session_rule_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "session_rule_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
static inline cJSON *vl_api_session_rules_dump_t_tojson (vl_api_session_rules_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "session_rules_dump");
    return o;
}
static inline cJSON *vl_api_session_rules_details_t_tojson (vl_api_session_rules_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "session_rules_details");
    cJSON_AddItemToObject(o, "transport_proto", vl_api_transport_proto_t_tojson(a->transport_proto));
    cJSON_AddItemToObject(o, "lcl", vl_api_prefix_t_tojson(&a->lcl));
    cJSON_AddItemToObject(o, "rmt", vl_api_prefix_t_tojson(&a->rmt));
    cJSON_AddNumberToObject(o, "lcl_port", a->lcl_port);
    cJSON_AddNumberToObject(o, "rmt_port", a->rmt_port);
    cJSON_AddNumberToObject(o, "action_index", a->action_index);
    cJSON_AddNumberToObject(o, "appns_index", a->appns_index);
    cJSON_AddItemToObject(o, "scope", vl_api_session_rule_scope_t_tojson(a->scope));
    cJSON_AddStringToObject(o, "tag", (char *)a->tag);
    return o;
}
#endif
