/* Imported API files */
#include <vnet/ip/ip_types.api_fromjson.h>
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_vxlan_gbp_api_fromjson_h
#define included_vxlan_gbp_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

#pragma GCC diagnostic ignored "-Wunused-label"
static inline int vl_api_vxlan_gbp_api_tunnel_mode_t_fromjson(void **mp, int *len, cJSON *o, vl_api_vxlan_gbp_api_tunnel_mode_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "VXLAN_GBP_API_TUNNEL_MODE_L2") == 0) {*a = 1; return 0;}
    if (strcmp(p, "VXLAN_GBP_API_TUNNEL_MODE_L3") == 0) {*a = 2; return 0;}
    *a = 0;
    return -1;
}
static inline int vl_api_vxlan_gbp_tunnel_t_fromjson (void **mp, int *len, cJSON *o, vl_api_vxlan_gbp_tunnel_t *a) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));

    item = cJSON_GetObjectItem(o, "instance");
    if (!item) goto error;
    vl_api_u32_fromjson(item, &a->instance);

    item = cJSON_GetObjectItem(o, "src");
    if (!item) goto error;
    if (vl_api_address_t_fromjson(mp, len, item, &a->src) < 0) goto error;

    item = cJSON_GetObjectItem(o, "dst");
    if (!item) goto error;
    if (vl_api_address_t_fromjson(mp, len, item, &a->dst) < 0) goto error;

    item = cJSON_GetObjectItem(o, "mcast_sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson(mp, len, item, &a->mcast_sw_if_index) < 0) goto error;

    item = cJSON_GetObjectItem(o, "encap_table_id");
    if (!item) goto error;
    vl_api_u32_fromjson(item, &a->encap_table_id);

    item = cJSON_GetObjectItem(o, "vni");
    if (!item) goto error;
    vl_api_u32_fromjson(item, &a->vni);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson(mp, len, item, &a->sw_if_index) < 0) goto error;

    item = cJSON_GetObjectItem(o, "mode");
    if (!item) goto error;
    if (vl_api_vxlan_gbp_api_tunnel_mode_t_fromjson(mp, len, item, &a->mode) < 0) goto error;

    return 0;

  error:
    return -1;
}
static inline vl_api_vxlan_gbp_tunnel_add_del_t *vl_api_vxlan_gbp_tunnel_add_del_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gbp_tunnel_add_del_t);
    vl_api_vxlan_gbp_tunnel_add_del_t *a = malloc(l);

    item = cJSON_GetObjectItem(o, "is_add");
    if (!item) goto error;
    vl_api_bool_fromjson(item, &a->is_add);

    item = cJSON_GetObjectItem(o, "tunnel");
    if (!item) goto error;
    if (vl_api_vxlan_gbp_tunnel_t_fromjson((void **)&a, &l, item, &a->tunnel) < 0) goto error;

    *len = l;
    return a;

  error:
    free(a);
    return 0;
}
static inline vl_api_vxlan_gbp_tunnel_add_del_reply_t *vl_api_vxlan_gbp_tunnel_add_del_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gbp_tunnel_add_del_reply_t);
    vl_api_vxlan_gbp_tunnel_add_del_reply_t *a = malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    free(a);
    return 0;
}
static inline vl_api_vxlan_gbp_tunnel_dump_t *vl_api_vxlan_gbp_tunnel_dump_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gbp_tunnel_dump_t);
    vl_api_vxlan_gbp_tunnel_dump_t *a = malloc(l);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    free(a);
    return 0;
}
static inline vl_api_vxlan_gbp_tunnel_details_t *vl_api_vxlan_gbp_tunnel_details_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_vxlan_gbp_tunnel_details_t);
    vl_api_vxlan_gbp_tunnel_details_t *a = malloc(l);

    item = cJSON_GetObjectItem(o, "tunnel");
    if (!item) goto error;
    if (vl_api_vxlan_gbp_tunnel_t_fromjson((void **)&a, &l, item, &a->tunnel) < 0) goto error;

    *len = l;
    return a;

  error:
    free(a);
    return 0;
}
static inline vl_api_sw_interface_set_vxlan_gbp_bypass_t *vl_api_sw_interface_set_vxlan_gbp_bypass_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vxlan_gbp_bypass_t);
    vl_api_sw_interface_set_vxlan_gbp_bypass_t *a = malloc(l);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    item = cJSON_GetObjectItem(o, "is_ipv6");
    if (!item) goto error;
    vl_api_bool_fromjson(item, &a->is_ipv6);

    item = cJSON_GetObjectItem(o, "enable");
    if (!item) goto error;
    vl_api_bool_fromjson(item, &a->enable);

    *len = l;
    return a;

  error:
    free(a);
    return 0;
}
static inline vl_api_sw_interface_set_vxlan_gbp_bypass_reply_t *vl_api_sw_interface_set_vxlan_gbp_bypass_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_sw_interface_set_vxlan_gbp_bypass_reply_t);
    vl_api_sw_interface_set_vxlan_gbp_bypass_reply_t *a = malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    *len = l;
    return a;

  error:
    free(a);
    return 0;
}
#endif
