/* Imported API files */
#include <vnet/ip/ip_types.api_tojson.h>
#include <vnet/interface_types.api_tojson.h>
#ifndef included_vxlan_gbp_api_tojson_h
#define included_vxlan_gbp_api_tojson_h
#include <vppinfra/cJSON.h>

#include <vat2/jsonconvert.h>

static inline cJSON *vl_api_vxlan_gbp_api_tunnel_mode_t_tojson (vl_api_vxlan_gbp_api_tunnel_mode_t a) {
    switch(a) {
    case 1:
        return cJSON_CreateString("VXLAN_GBP_API_TUNNEL_MODE_L2");
    case 2:
        return cJSON_CreateString("VXLAN_GBP_API_TUNNEL_MODE_L3");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_vxlan_gbp_tunnel_t_tojson (vl_api_vxlan_gbp_tunnel_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddNumberToObject(o, "instance", a->instance);
    cJSON_AddItemToObject(o, "src", vl_api_address_t_tojson(&a->src));
    cJSON_AddItemToObject(o, "dst", vl_api_address_t_tojson(&a->dst));
    cJSON_AddNumberToObject(o, "mcast_sw_if_index", a->mcast_sw_if_index);
    cJSON_AddNumberToObject(o, "encap_table_id", a->encap_table_id);
    cJSON_AddNumberToObject(o, "vni", a->vni);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddItemToObject(o, "mode", vl_api_vxlan_gbp_api_tunnel_mode_t_tojson(a->mode));
    return o;
}
static inline cJSON *vl_api_vxlan_gbp_tunnel_add_del_t_tojson (vl_api_vxlan_gbp_tunnel_add_del_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "vxlan_gbp_tunnel_add_del");
    cJSON_AddBoolToObject(o, "is_add", a->is_add);
    cJSON_AddItemToObject(o, "tunnel", vl_api_vxlan_gbp_tunnel_t_tojson(&a->tunnel));
    return o;
}
static inline cJSON *vl_api_vxlan_gbp_tunnel_add_del_reply_t_tojson (vl_api_vxlan_gbp_tunnel_add_del_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "vxlan_gbp_tunnel_add_del_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_vxlan_gbp_tunnel_dump_t_tojson (vl_api_vxlan_gbp_tunnel_dump_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "vxlan_gbp_tunnel_dump");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_vxlan_gbp_tunnel_details_t_tojson (vl_api_vxlan_gbp_tunnel_details_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "vxlan_gbp_tunnel_details");
    cJSON_AddItemToObject(o, "tunnel", vl_api_vxlan_gbp_tunnel_t_tojson(&a->tunnel));
    return o;
}
static inline cJSON *vl_api_sw_interface_set_vxlan_gbp_bypass_t_tojson (vl_api_sw_interface_set_vxlan_gbp_bypass_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "sw_interface_set_vxlan_gbp_bypass");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    cJSON_AddBoolToObject(o, "is_ipv6", a->is_ipv6);
    cJSON_AddBoolToObject(o, "enable", a->enable);
    return o;
}
static inline cJSON *vl_api_sw_interface_set_vxlan_gbp_bypass_reply_t_tojson (vl_api_sw_interface_set_vxlan_gbp_bypass_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "sw_interface_set_vxlan_gbp_bypass_reply");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
#endif
